libcamera::FrameMetadata Struct Reference

Metadata related to a captured frame. More...

## Classes

struct | Plane
| Per-plane frame metadata. More...

## Public Types

enum | Status { FrameSuccess , FrameError , FrameCancelled }
| Define the frame completion status. More...

## Public Attributes

Status | status
| Status of the frame. More...
unsigned int | sequence
| Frame sequence number. More...
uint64_t | timestamp
| Time when the frame was captured. More...
std::vector< Plane > | planes
| Array of per-plane metadata.

## Detailed Description

Metadata related to a captured frame.

The FrameMetadata structure stores all metadata related to a captured frame, as stored in a FrameBuffer, such as capture status, timestamp and bytesused.

## Member Enumeration Documentation

## Status

enum libcamera::FrameMetadata::Status

Define the frame completion status.

Enumerator
FrameSuccess | The frame has been captured with success and contains valid data. All fields of the FrameMetadata structure are valid.
FrameError | An error occurred during capture of the frame. The frame data may be partly or fully invalid. The sequence and timestamp fields of the FrameMetadata structure is valid, the other fields may be invalid.
FrameCancelled | Capture stopped before the frame completed. The frame data is not valid. All fields of the FrameMetadata structure but the status field are invalid.

## Member Data Documentation

## sequence

libcamera::FrameMetadata::sequence

Frame sequence number.

The sequence number is a monotonically increasing number assigned to the frames captured by the stream. The value is increased by one for each frame. Gaps in the sequence numbers indicate dropped frames.

## status

libcamera::FrameMetadata::status

Status of the frame.

The validity of other fields of the FrameMetadata structure depends on the status value.

## timestamp

libcamera::FrameMetadata::timestamp

Time when the frame was captured.

The timestamp is expressed as a number of nanoseconds relative to the system clock since an unspecified time point.

Todo:
  Be more precise on what timestamps refer to.

The documentation for this struct was generated from the following files:

- include/libcamera/buffer.h
- src/libcamera/buffer.cpp